-- local LSM = LibStub("LibSharedMedia-3.0")
-- local VSL = LibStub("VikingSharedLib")
local Taka = LibStub("Taka-0.0")

local addonName, addon = ...
local PlayerUnitFrame = Taka:NewClass("Button", "VH_UnitFrame", "SecureUnitButtonTemplate")
addon.PlayerUnitFrame = PlayerUnitFrame

function PlayerUnitFrame:New(parent, side, unitID)
  local frame = PlayerUnitFrame:Super(PlayerUnitFrame):New(parent)
  frame.unitID = unitID
  frame:EnableMouse(true)
  frame:RegisterForClicks("LeftButtonUp", "RightButtonUp")
  frame:SetAttribute("type1", "target")
  frame:SetAttribute("type2", "togglemenu")
  frame:SetAttribute("unit", unitID)

  local dirMod = side == "LEFT" and -1 or 1
  local dirPoint = side == "LEFT" and "RIGHT" or "LEFT"
  local dirPointRelative = side == "LEFT" and "LEFT" or "RIGHT"
  frame.dirMod = dirMod
  frame.dirPoint = dirPoint
  frame.dirPointRelative = dirPointRelative

  local frameHeight = addon.Settings.db.profile.height + addon.Settings.db.profile.fontSize + 4

  frame:SetSize(
    (addon.Settings.db.profile.width * 2) + addon.Settings.db.profile.spacing,
    frameHeight
  )
  frame:SetPoint("TOP", parent, "TOP", 0, unitID == "target" and frameHeight + addon.Settings.db.profile.spacingY or 0)

  frame.container = addon.Frame:Super(addon.Frame):New(frame)
  frame.container:SetAllPoints(frame)

  frame.health = addon.PlayerHealthFrame:New(frame.container, "LEFT", frame.unitID)
  frame.health:SetPoint("TOP" .. dirPointRelative, frame.container, "TOP" .. dirPointRelative, 0, 0)

  frame.mana = addon.PlayerPowerFrame:New(frame.container, "RIGHT", frame.unitID, 0)
  frame.mana:SetPoint("TOP" .. dirPoint, frame.container, "TOP" .. dirPoint, 0, 0)

  frame.energy = addon.PlayerPowerFrame:New(frame.container, "RIGHT", frame.unitID, 3)
  frame.energy:SetPoint("TOP" .. dirPoint, frame.container, "TOP" .. dirPoint, 0, 0)

  frame.rage = addon.PlayerPowerFrame:New(frame.container, "RIGHT", frame.unitID, 1)
  frame.rage:SetPoint("TOP" .. dirPoint, frame.container, "TOP" .. dirPoint, 0, 0)

