-- local LSM = LibStub("LibSharedMedia-3.0")
local VSL = LibStub("VikingSharedLib")
local Taka = LibStub("Taka-0.0")

local addonName, addon = ...
local TargetUnitFrameBase = {}
local TargetUnitFrame = {}; addon.TargetUnitFrame = TargetUnitFrame

local function new(parent, side, unitID)
  local frame = CreateFrame("Button", "VH_TargetTargetFrame", parent, "SecureUnitButtonTemplate")
  VSL:ApplyMixin(frame, TargetUnitFrameBase)
  frame.unitID = unitID
  frame:EnableMouse(true)
  frame:RegisterForClicks("LeftButtonUp", "RightButtonUp")
  frame:SetAttribute("type1", "target")
  frame:SetAttribute("type2", "togglemenu")
  frame:SetAttribute("unit", unitID)

  local dirMod = side == "LEFT" and -1 or 1
  local dirPoint = side == "LEFT" and "RIGHT" or "LEFT"
  local dirPointRelative = side == "LEFT" and "LEFT" or "RIGHT"
  frame.dirMod = dirMod
  frame.dirPoint = dirPoint
  frame.dirPointRelative = dirPointRelative

  frame:SetSize(
    addon.Settings.db.profile.spacing - 20,
    addon.Settings.db.profile.height + addon.Settings.db.profile.fontSize + 4
  )
  frame:SetPoint("TOPLEFT", parent, "TOPRIGHT", 20, 0)

  frame.container = addon.Frame:Super(addon.Frame):New(frame)
  frame.container:SetAllPoints(frame)

